-----------------------------------------------------------------
-- (c) 2007 VUT-FEL, K336
-- http://cs.felk.cvut.cz
-----------------------------------------------------------------
-- Filename : add8cz.vhd
-- Revision : V1.0
-- Author :   Zdenk Sojka
-- Created :  18. 04. 2007
--
-- Modifications
-- 1.0	22. 04. 2007 by Zdenk Sojka
-----------------------------------------------------------------
-- staka, umouje pevod carry pi delm stn
--
--	vstupy	: data pro stn
--				  zen penosu carry
-- vstupy	: hodnota soutu (neregistrovan)
--
-- 1.0	prava itelnosti kdu
-----------------------------------------------------------------

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity add8cz is
    Port ( in1 : in  std_logic_vector(7 downto 0);	-- vstup - prvn operand pro stn
           in2 : in  std_logic_vector(7 downto 0);	-- vstup - druh operand
           k2	: in  std_logic;							-- pkaz - penos carry z minulho soutu

           sum : out std_logic_vector(7 downto 0);	-- vstup - souet (neregistrovan)

           clk : in  std_logic;
           rst : in  std_logic );
end add8cz;

architecture rtl of add8cz is

signal c_r : std_logic;		-- registrovan carry
signal c_nxt : std_logic;	-- nov hodnota carry
signal c1 : std_logic;		-- mezivpoet - vstupn carry do staky
signal sum_i : std_logic_vector ( 7 downto 0 );	-- souet

component add8gen
	port ( A, B : in std_logic_vector ( 7 downto 0 );	-- stance
			C_IN : in std_logic;									-- vstupn carry
			C_OUT : out std_logic;								-- vstupn carry
			S : out std_logic_vector ( 7 downto 0 )		-- vstupn hodnota
			);
end component;

begin

	c1 <= c_r and k2;

	scitacka : add8gen port map (
		A => in1, B => in2, C_IN => c1,
		S => sum_i, C_OUT => c_nxt );

	secist : process ( clk ) is
	begin
--		if rst then		-- pri resetu neni potreba nic nastavovat - prenos je rizen signalem k2
		if ( clk = '1' ) and clk'event then
			c_r <= c_nxt;
		end if;
	end process;

	sum <= sum_i;

end rtl;

