-----------------------------------------------------------------
-- (c) 2007 VUT-FEL, K336
-- http://cs.felk.cvut.cz
-----------------------------------------------------------------
-- Filename : registrA.vhd
-- Revision : V1.0
-- Author :   Zdenk Sojka
-- Created :  19. 04. 2007
--
-- Modifications
-- 1.0	22. 04. 2007 by Zdenk Sojka
-----------------------------------------------------------------
-- registr A, 8bit, umouje posun doprava
--
--	vstupy	: nastaven hodnoty
--				  zen posunu
-- vstupy	: pznak nulovho registru (neregistrovan)
--				  pznak nulovho spodnho bitu (neregistrovan)
--
-- 1.0	prava itelnosti kdu
-----------------------------------------------------------------

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity registrA is
   port (
		sw		: in	std_logic_vector (7 downto 0);	-- hodnota pro nastaven
		set	: in	std_logic;								-- pkaz - nastavit registr
		shr	: in	std_logic;								-- pkaz - posun doprava

		zero	: out std_logic;								-- pznak - nulov registr
		zero0	: out std_logic;								-- pznak - nulov nejni bit

		clk	: in	std_logic;
		rst	: in	std_logic );
end registrA;

architecture rtl of registrA is

signal val, val_nxt : std_logic_vector (7 downto 0);	-- registr a jeho dal hodnota
signal zero_s : std_logic;

begin

	val_nxt <= (others=>'0') when rst = '1' else	-- je to potreba?
			sw when set = '1' else
			"0" & val(7 downto 1) when shr = '1' else
			val;

	zero <= '1' when val_nxt = 0 else '0';
	zero0 <= not val_nxt(0);

	nastav : process ( clk, rst ) is
	begin
		if ( rst = '1' ) then
			val <= (others=>'0');
		elsif ( clk = '1' and clk'event ) then
			val <= val_nxt;
		end if;
	end process;

end rtl;

