-----------------------------------------------------------------
-- (c) 2007 VUT-FEL, K336
-- http://cs.felk.cvut.cz
-----------------------------------------------------------------
-- Filename : registrB.vhd
-- Revision : V1.0
-- Author :   Zdenk Sojka
-- Created :  19. 04. 2007
--
-- Modifications
-- 1.0	22. 04. 2007 by Zdenk Sojka
-----------------------------------------------------------------
-- registr B, 16bit, umouje posun doleva
--
--	vstupy	: nastaven hodnoty
--				  zen posunu
-- vstupy	: hodnota registru
--
-- 1.0	prava itelnosti kdu
-----------------------------------------------------------------

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity registrB is
   port (
		sw		: in	std_logic_vector (15 downto 0);	-- hodnota pro nastaven
		set	: in	std_logic;								-- pkaz - nastaven registru
		shl	: in	std_logic;								-- pkaz - posun registru doleva

		val	: out	std_logic_vector (15 downto 0);	-- vstup - hodnota registru

		clk	: in	std_logic;
		rst	: in	std_logic );
end registrB;

architecture rtl of registrB is

signal val_nxt : std_logic_vector (15 downto 0);	-- uren nov hodnoty registru
signal val_i : std_logic_vector (15 downto 0);

begin

	val_nxt <= (others=>'0') when rst = '1' else
			sw when set = '1' else
			val_i(14 downto 0) & "0" when shl = '1' else
			val_i;

	nastav : process ( clk, rst ) is
	begin
		if ( rst = '1' ) then
			val_i <= (others=>'0');
		elsif ( clk = '1' and clk'event ) then
			val_i <= val_nxt;
		end if;
	end process;

	val <= val_i;


end rtl;

