-----------------------------------------------------------------
-- (c) 2007 VUT-FEL, K336
-- http://cs.felk.cvut.cz
-----------------------------------------------------------------
-- Filename : add8cztb.vhd
-- Revision : V1.1
-- Author :   Josef Nouzk
-- Created :  22. 04. 2007
--
-- Modifications
-- 1.1	22. 04. 2007 by Zdenk Sojka
-- 1.0	22. 04. 2007 by Josef Nouzk
-----------------------------------------------------------------
-- testbench pro adder - zkou obyejn souet a souet s penosem
--
-- 1.1	dodln test penosu
-----------------------------------------------------------------

LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.std_logic_unsigned.all;
USE ieee.numeric_std.ALL;

ENTITY add8cztb_vhd IS
END add8cztb_vhd;

ARCHITECTURE behavior OF add8cztb_vhd IS 

	-- Component Declaration for the Unit Under Test (UUT)
	COMPONENT add8cz
	PORT(
		in1 : IN std_logic_vector(7 downto 0);
		in2 : IN std_logic_vector(7 downto 0);
		clk : IN std_logic;
		rst : IN std_logic;
		k2 : IN std_logic;          
		sum : OUT std_logic_vector(7 downto 0)
		);
	END COMPONENT;

	--Inputs
	SIGNAL clk :  std_logic := '0';
	SIGNAL rst :  std_logic := '0';
	SIGNAL k2 :  std_logic := '0';
	SIGNAL in1 :  std_logic_vector(7 downto 0) := (others=>'0');
	SIGNAL in2 :  std_logic_vector(7 downto 0) := (others=>'0');

	--Outputs
	SIGNAL sum :  std_logic_vector(7 downto 0);

BEGIN

	-- Instantiate the Unit Under Test (UUT)
	uut: add8cz PORT MAP(
		in1 => in1,
		in2 => in2,
		sum => sum,
		clk => clk,
		rst => rst,
		k2 => k2
	);

 	hodiny : process
	
	begin
		clk <= '0';
		wait for 10 ns;
		clk <= '1';
		wait for 10 ns;
	end process;

	tb : PROCESS
	BEGIN

		-- Wait 100 ns for global reset to finish
		wait for 100 ns;
		in1 <= "11011010";
		in2 <= "10011001";
		wait for 100 ns;
		assert (sum="01110011") report "Error! chyba 1. vypoctu" severity error;		
		k2 <= '1';
		in1 <= "11011010";
		in2 <= "10011001";
		wait for 100 ns;
		assert (sum="01110100") report "Error! chyba 2. vypoctu" severity error;


		-- Place stimulus here

		wait; -- will wait forever
	END PROCESS;

END;
