-----------------------------------------------------------------
-- (c) 2007 VUT-FEL, K336
-- http://cs.felk.cvut.cz
-----------------------------------------------------------------
-- Filename : buff.vhd
-- Revision : V1.0
-- Author :   Zdenk Sojka
-- Created :  20. 04. 2007
--
-- Modifications
-- 1.0	22. 04. 2007 by Zdenk Sojka
-----------------------------------------------------------------
-- provd buffer vstup btns(1:0) a swtch
-- vyle signl btnA, btnB pi stisku tlatka
--		(pi zmn stavu 0 -> 1)
--
-- vstupy	: vstupy od uivatele
-- vstupy	: registrovan vstupy, signly
--
-- 1.0	prava itelnosti kdu
-----------------------------------------------------------------

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity buff is
	port (
		btns : in std_logic_vector(1 downto 0);
		swtch : in std_logic_vector(7 downto 0);

		btnA : out std_logic;
		btnB : out std_logic;
		sw : out std_logic_vector(7 downto 0);

		clk : in std_logic;
		rst : in std_logic);
end buff;

architecture rtl of buff is

signal btnA_i, btnB_i, btnA_nxt, btnB_nxt : std_logic;
signal btns_p : std_logic_vector(1 downto 0);

begin

	zaznam : process ( rst, clk ) is
	
	begin
		if ( rst = '1' ) then
			btnA_i <= '0';
			btnB_i <= '0';
			btns_p <= "00";
			sw <= (others=>'0');
		elsif ( clk = '1' ) and clk'event then
			btnA_i <= btns(0) and not btns_p(0);
			btnB_i <= btns(1) and not btns_p(1);
			btns_p <= btns(1 downto 0);
			sw <= swtch;
		end if;
	end process;

	btnA <= btnA_i;
	btnB <= btnB_i;

end rtl;

