-----------------------------------------------------------------
-- (c) 2007 VUT-FEL, K336
-- http://cs.felk.cvut.cz
-----------------------------------------------------------------
-- Filename : mem_ctrl.vhd
-- Revision : V1.0
-- Author :   Zdenk Sojka
-- Created :  21. 04. 2007
--
-- Modifications
-- 1.0	22. 04. 2007 by Zdenk Sojka
-----------------------------------------------------------------
-- pam mikroinstrukc
-- syntetizovan jako ROM
-- v thle form je vce srozumoteln ne jako IP core
--
-- vstupy	: adresa
-- vstupy	: opkd mikroinstrukce
--
-- 1.0	prava itelnosti kdu
-----------------------------------------------------------------

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity mem_ctrl is
    Port ( Addr : in std_logic_vector(2 downto 0);
           Data : out std_logic_vector(11 downto 0));

end mem_ctrl;

architecture rtl of mem_ctrl is

TYPE t_mem IS array(0 TO 7) OF std_logic_vector(11 DOWNTO 0);

constant cm: t_mem := (
	-- format dat:
	-- naddr(3) vp(2) k2 k1 resV load shift setB setA

	-- vyber podminky:
	-- 00	bez podminky
	-- 01	( btnA or btnB ) btnB
	-- 10	zero0 zeroA
	-- 11	nedefinovane

	-- 000000		-- instrukce pri resetu
	"000010001000",	-- adresa 0, rozskok podle zmacknutych tlacitek
	-- 000001
	"000000000000",	-- nemuze nastat rozskokem podle tlacitek
	-- 000010
	"100100010001",	-- stisk btnA, nacist a reset vysledku, zacit vypocet
	-- 000011
	"100100010010",	-- stisk btnB (pripadne i btnA)

	-- 000100		; cil skoku - posledni dva bity = zero0 zeroA
	--				;		plati implikace zeroA => zero0
	"101000100000",	-- !zero0 & !zeroA - zacit scitani
	-- 000101
	"100101000100",	-- !zero0 & zeroA - nemuze nastat - vyuzito jako druhy krok scitani!
	-- 000110
	"100100000100",	-- zero0 & !zeroA - preskocit tento krok scitani, novy rozskok
	-- 000111
	"000010001000"	-- zero0 & zeroA - nulovy regA, zpet na detekci tlacitek
);

begin

Data <= cm(conv_integer(Addr));

end rtl;

